# GSoC Ideas List: `aimacode`

# (Note: `aimacode` is not participating in GSOC for 2020)

In the past, the <a href="https://github.com/aimacode"><tt>aimacode</tt></a> project has enjoyed the support of the Google
Summer of Code. We may do so again in 2021. We had a few student interns help write code. Here are some of the requirements and project ideas from past years:

<ul>
	<li> Very strong coding ability. Give us a link to some projects you've done.
	<li> Very <i>clear</i> coding, commenting, and documentation writing skills.
Your code not only has to be correct, it also has to be easy top understand, and easy to see the connection between your code and
the description of the algorithms in the textbook. 
    <li> Enthusiasm for helping other people by explaining things well.
		Show us some examples of your work in this area.
	<li> Some experience, or familiarity, or willingness to learn about artificial intelligence
		and machine learning.
</ul>


<h1>Project Ideas</h1>

<h2>(1) Exercises Website</h2>

Unlike the previous editions, the upcoming 4th edition of <a
href="http://aima.cs.berkeley.edu/"><i>Artificial Intelligence: A Modern Approach</i></a> will not have
exercises in the book; they will be online only. We need help in launching a website for the
exercises, and in developing some new exercises and answers. Last year we got a good start on the
project; this year we need to finish the interface, refine the mechanism for showing answers and
hints, test it, and do performance load measurements to make sure it will hold up under load.
<b>Skills:</b> testing, user interface design.
<b>Possible mentors:</b> Nalin Chhibber
	
<h2>(2) Java Algorithms</h2>

Finish implementing all the pseudocode algorithms in the book in Java. A majority of the algorithms
from the 3rd edition are done, but there are some new ones in the upcoming 4th edition, as
described in the <a href="https://github.com/aimacode/aima-pseudocode"><tt>aima-pseudocode</tt></a>
project. Make sure the code follows the pseudocode well, and also shows good style. Also, provide
examples of usage, documentation, and thorough test cases.
<b>Skills:</b> Java programming, documentation.
<b>Possible mentors:</b> Peter Norvig

<h2>(3) Python Algorithms</h2>

Finish implementing all the pseudocode algorithms in the book in Python. Almost all of the
algorithms from the 3rd edition are done, but there are some new ones in the upcoming 4th edition,
as described in the <a
href="https://github.com/aimacode/aima-pseudocode"><tt>aima-pseudocode</tt></a> project. Make sure
the code follows the pseudocode well, and also shows good style. Also, provide examples of usage,
documentation, and thorough test cases.
<b>Skills:</b> Python programming, documentation.
<b>Possible mentors:</b> Pierre de Lacaze

<h2>(4) Example Notebooks</h2>
	
Using Jupyter/IPython or similar mechanisms, develop example worked projects that demonstrate the use of the algorithms from (2) and (3) above to solve interesting problems. Examples could include game playing, natural language processing, machine learning, and other topics, depending on your interest.
<b>Skills:</b> Python programming, writing clearly.
<b>Possible mentors:</b> Pierre de Lacaze

<h2>(5) Container Notebooks</h2>

Continuing the theme from (4) above, but demonstrating how to load an existing third-party open
source framework, such as TensorFlow, Theano, Caffe, Keras, Torch, Stanford CoreNLP, NLTK, Sci-kit Learn, or Spark. Create a container (Docker or Kubernetes) that has all the dependencies, and a notebook and documentation that shows how to use it to solve an interesting real-world problem or set of problems.
<b>Skills:</b> familiarity with containers, attention to detail, good at explanations.
<b>Possible mentors:</b> Peter Norvig

<h2>(6) Javascript Gridworld</h2>

We have code for agents learning, searching, and acting in a grid layout. We need better visualizations of that it Javascript. Make it possible for students to examine existing problems and see what is going on through a simulation of the world, and visualization of various key metrics. Make it easy to define a new world, or to define a new agent function and run it within the world.
<b>Skills:</b> User interface design, Javascript programming.
<b>Possible mentors:</b> Sam Goto

<h1>GSoC Application Process</h1>

If you'd like to help, you can <a href="https://developers.google.com/open-source/gsoc/timeline">apply to GSoC</a>. 
<p>
See:
<ul>
<li> <a href="https://summerofcode.withgoogle.com/organizations/5663121491361792/">aimacode <b>GSoC</b> Page</a>
<li> <a href="https://github.com/aimacode">aimacode <b>Github</b> Page</a>
<li> <a href="https://gitter.im/aimacode/Lobby">aimacode <b>Chat</b> Room</a>
<li> <a href="mailto:peter.norvig+gsoc@gmail.com">aimacode <b>mail</b>
	 address</a>
<li> Past GSoC projects: 
	<a href="https://summerofcode.withgoogle.com/archive/2018/organizations/5756292874371072/">2018</a>,
	<a href="https://summerofcode.withgoogle.com/archive/2017/organizations/6119722806411264/#projects">2017</a>,
	<a href="https://summerofcode.withgoogle.com/archive/2016/organizations/5549354102292480/#projects">2016</a>
</ul>
